<?php

// Note, assumes client is 2 dirs down, e.g. websites/katie/chat.php
// May need to make absolute if location varies (relative is easier though)
// If there are problems getting relative location, "dirname(__FILE__)" should do it
// Note also that the file 'chat.txt' must be writable
// On Unix/Linux, you could cd into the directory and do "chmod 766 chat.txt"
// define('CHAT_FILENAME', 'chat.txt');
define('CHAT_FILENAME', dirname(__FILE__) . "/" . 'chat.txt');

// Returns the contents of the chat file as a string
function print_chat($num_lines=20) {
  write_hidden_fields();
  $chat_file = fopen(CHAT_FILENAME,'rb');
  if ($num_lines < 1) $num_lines = 1;
  if ($chat_file) {
    $lines = array();
	for ($line = fgets($chat_file); !feof($chat_file); $line = fgets($chat_file)) {
	  $lines[] = $line;
	}
	print implode('', array_slice($lines, -$num_lines));
  }
  fclose($chat_file);
}

// Writes to the chat file
function write_to_chat($name, $color, $text)
{
  $chat_file = fopen(CHAT_FILENAME,'ab');
  fwrite($chat_file, "<font color=\"$color\"><strong>$name:</strong></font> ");
  fwrite($chat_file, htmlentities($text) . "<br />\n");
  fclose($chat_file);
}

// Get inputs from post and write to chat
function write_from_post()
{
  // Set default values
  $name = '';
  $color = 'black';
  $text = '';
	
  // Get name from post
  $bad_input = false;
  if (array_key_exists('name', $_POST) && $_POST['name']) {
	$name = $_POST['name'];
  } else {
    // If no name, forget it
    $bad_input = true;
  }
	
  // Get color
  if (array_key_exists('color', $_POST) && $_POST['color']) {
	$color = $_POST['color'];
  }
	
  // Get text
  if (array_key_exists('text', $_POST) && $_POST['text']) {
	$text = $_POST['text'];
  }
	
  // Write to chat
  if (!$bad_input) write_to_chat($name, $color, $text);
}

// Clear chat file
function clear_chat()
{
  $chat_file = fopen(CHAT_FILENAME,'wb');
  fclose($chat_file);
}

// Get post value
function print_value($field) {
  $value = "";
  if (array_key_exists($field, $_POST)) {
    $value = " value=\"" . $_POST[$field] . "\"";
  }
  print $value;
}

// Write hidden fields
function write_hidden_fields() {
  print '<input type="hidden" name="name"';
  print_value('name');
  print ">\n";
  print '<input type="hidden" name="color"';
  print_value('color');
  print ">\n";
}

// Handle any actions submitted
if (array_key_exists('clear', $_POST)) {
  clear_chat();
} elseif (array_key_exists('say', $_POST)) {
  write_from_post();
}
?>